import matplotlib.pyplot as plt
import numpy as np
import scipy.stats
import seaborn

a = 7 + 1
b = 10 - 7 + 1
N = 10

k_values = []
p_samples = []
for t in range(10000):
    p = scipy.stats.beta.rvs(a, b)
    k = scipy.stats.binom.rvs(N, p)
    p_samples.append(p)
    k_values.append(k)

p_values = np.arange(0.0, 1.0, 0.01)
p_beta = scipy.stats.beta.pdf(p_values, a, b)
plt.plot(p_values, p_beta, linestyle = '--', color = 'k',
         linewidth = 3, label = 'Beta(7+1, 3+1)')
plt.hist(p_samples, bins = 20, density = True, color = 'b', alpha = 0.5)
seaborn.kdeplot(p_samples, linewidth = 3, color = 'r',label = 'KDE plot')
plt.yticks([])
plt.xlabel('p', fontsize = 14)
plt.legend(loc = 'upper left', fontsize = 14)
plt.title('Sample Distribution of p', fontsize = 16)
plt.show()

plt.hist(k_values, bins = np.arange(-0.25, 10.75, 0.5), density = True)
plt.vlines(7, 0, 0.4, color = 'r', linewidth = 3, label = 'k = 7')
plt.xlabel('k', fontsize = 16)
plt.legend(loc = 'upper left', fontsize = 16)
plt.title('Posterior predictive distribution of k', fontsize = 16)
plt.show()
